<?php
namespace Geral\Repositories;

class Diafecmes extends \Doctrine\ORM\EntityRepository
{


    /**
     * Retorna o registro da data de fechamento de um determinado mes.
     *
     * @param $nrorg
     * @param $filial
     * @param $primeiroDia
     * @param $ultimoDia
     *
     * @return bool|mixed
     */
    public function consultaDataFechMes($nrorg, $filial, $primeiroDia, $ultimoDia){
        $sql = 'SELECT D.*
                  FROM DIAFECMES D
                 WHERE D.NRORG    = :P_NRORG
                   AND D.CDFILIAL = :P_CDFILIAL
                   AND D.DTFECMES
               BETWEEN :P_PRIMEIRODIA AND :P_ULTIMODIA';

        $params = array(
            'P_NRORG'       => $nrorg,
            'P_CDFILIAL'    => $filial,
            'P_PRIMEIRODIA' => $primeiroDia,
            'P_ULTIMODIA'   => $ultimoDia,
        );

        $entityManager = $this->getEntityManager();
        $resultSetMapping = new \Doctrine\ORM\Query\ResultSetMappingBuilder($entityManager);
        $resultSetMapping->addRootEntityFromClassMetadata('Geral\Entities\Diafecmes', "D");

        $result = $entityManager->createNativeQuery($sql, $resultSetMapping)->execute($params);
        return is_array($result) ? current($result) : false;
    }


}