/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_EQUIPETRAB                                               */
/* Tabela : EQUIPETRAB                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 28/02/2007 - Rejane P. Leite                                               */
/*                                                                            */
/******************************************************************************/
CREATE OR REPLACE TRIGGER DTULTATU_EQUIPETRAB
BEFORE INSERT OR UPDATE OR DELETE
ON EQUIPETRAB FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUEQPT := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDEQUIPETRAB,0 )   <> NVL(:NEW.CDEQUIPETRAB,0))   OR
         (NVL(:OLD.NMEQUIPETRAB,0 )   <> NVL(:NEW.NMEQUIPETRAB,0)) THEN
         :NEW.DTULTATUEQPT := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('EQUIPETRAB', '','CDEQUIPETRAB='||:OLD.CDEQUIPETRAB||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE EQUIPETRAB MODIFY DTULTATUEQPT DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_EQUIPETRAB','5.03.010'); END;
/

