/* Tabela COMPENSACONTREC: Compensao de Conta a Receber */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela COMPENSACONTREC */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela "Compensao de Conta a Receber",
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIN_COMPENSACONTREC
AFTER DELETE OR INSERT OR UPDATE
ON COMPENSACONTREC FOR EACH ROW
DECLARE
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(400);
  V_DTOPER    DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF DELETING THEN
      IF :OLD.CDEMPRESA IS NOT NULL THEN
         V_DESC := SUBSTR(V_DESC || 'CdEmp=' || :OLD.CDEMPRESA, 1, 400);
      END IF;
      IF :OLD.NRLANCCOMPREC IS NOT NULL THEN
         V_DESC := SUBSTR(V_DESC || ' NroComp=' || :OLD.NRLANCCOMPREC, 1, 400);
      END IF;
      IF (:OLD.CDFILIAL IS NOT NULL) AND (:OLD.NRLANBOLREC IS NOT NULL) THEN
         V_DESC := SUBSTR(V_DESC || ' ChaveBol=' || :OLD.CDFILIAL || :OLD.NRLANBOLREC, 1, 400);
      END IF;
      IF :OLD.CDOPERLANCOMREC IS NOT NULL THEN
         V_DESC := SUBSTR(V_DESC || ' CdOpLanc=' || :OLD.CDOPERLANCOMREC, 1, 400);
      END IF;
      IF :OLD.DTLANCOMCONTREC IS NOT NULL THEN
         V_DESC := SUBSTR(V_DESC || ' DtLancC=' || TO_CHAR(:OLD.DTLANCOMCONTREC, 'DD/MM/YYYY'), 1, 400);
      END IF;
      IF :OLD.CDCLIENTE IS NOT NULL THEN
         V_DESC := SUBSTR(V_DESC || ' CdClie=' || :OLD.CDCLIENTE, 1, 400);
      END IF;
      IF :OLD.DTCOMPCONTREC IS NOT NULL THEN
         V_DESC := SUBSTR(V_DESC || ' DtCompRec=' || TO_CHAR(:OLD.DTCOMPCONTREC, 'DD/MM/YYYY'), 1, 400);
      END IF;
      IF :OLD.CDTPBAIXAREC IS NOT NULL THEN
         V_DESC := SUBSTR(V_DESC || ' TpBxRec=' || :OLD.CDTPBAIXAREC, 1, 400);
      END IF;
      IF :OLD.CDTPBAIXAPAG IS NOT NULL THEN
         V_DESC := SUBSTR(V_DESC || ' TpBxPag=' || :OLD.CDTPBAIXAPAG, 1, 400);
      END IF;
      IF :OLD.CDAJUCTREC IS NOT NULL THEN
         V_DESC := SUBSTR(V_DESC || ' TpAjRec=' ||  :OLD.CDAJUCTREC, 1, 400);
      END IF;
      IF :OLD.CDAJUCTPAG IS NOT NULL THEN
         V_DESC := SUBSTR(V_DESC || ' TpAjPag=' ||  :OLD.CDAJUCTPAG, 1, 400);
      END IF;
      IF :OLD.CDREDUCONT IS NOT NULL THEN
         V_DESC := SUBSTR(V_DESC || ' CdReCont=' || :OLD.CDREDUCONT, 1, 400);
      END IF;
      IF :OLD.DTBAIXACOMPREC IS NOT NULL THEN
         V_DESC := SUBSTR(V_DESC || ' DtBxComp=' || TO_CHAR(:OLD.DTBAIXACOMPREC, 'DD/MM/YYYY'), 1, 400);
      END IF;
      IF (:OLD.CDFILIALBAIREC IS NOT NULL) AND (:OLD.NRBAIXAREC IS NOT NULL) THEN
         V_DESC := SUBSTR(V_DESC || ' ChavBxRec=' || :OLD.CDFILIALBAIREC || :OLD.NRBAIXAREC, 1, 400);
      END IF;
      IF (:OLD.CDFILIALBAIPAG IS NOT NULL) AND (:OLD.NRBAIXAPAG IS NOT NULL) THEN
         V_DESC := SUBSTR(V_DESC || ' ChavBxPag=' || :OLD.CDFILIALBAIPAG || :OLD.NRBAIXAPAG, 1, 400);
      END IF;
      IF :OLD.IDTPITUTLCOMREC IS NOT NULL THEN
         V_DESC := SUBSTR(V_DESC || ' IdItem=' || :OLD.IDTPITUTLCOMREC, 1, 400);
      END IF;
      IF :OLD.QTITCOMCONTREC IS NOT NULL THEN
         V_DESC := SUBSTR(V_DESC || ' QtItens=' || TO_CHAR(:OLD.QTITCOMCONTREC), 1, 400);
      END IF;
      IF :OLD.VRTOTALCOMREC IS NOT NULL THEN
         V_DESC := SUBSTR(V_DESC || ' VrComp=' || TO_CHAR(:OLD.VRTOTALCOMREC), 1, 400);
      END IF;
      V_TIPO := '3';
      V_ITPESQ := :OLD.CDEMPRESA || :OLD.NRLANCCOMPREC;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.CDEMPRESA,       '0') <> NVL(:NEW.CDEMPRESA,       '0')) OR
            (NVL(:OLD.NRLANCCOMPREC,   '0') <> NVL(:NEW.NRLANCCOMPREC,   '0')) OR
            (NVL(:OLD.CDFILIAL,        '0') <> NVL(:NEW.CDFILIAL,        '0')) OR
            (NVL(:OLD.NRLANBOLREC,     '0') <> NVL(:NEW.NRLANBOLREC,     '0')) OR
            (NVL(:OLD.CDOPERLANCOMREC, '0') <> NVL(:NEW.CDOPERLANCOMREC, '0')) OR
            (NVL(TO_CHAR(:OLD.DTLANCOMCONTREC, 'DD/MM/YYYY'), '0') <> NVL(TO_CHAR(:NEW.DTLANCOMCONTREC, 'DD/MM/YYYY'), '0')) OR
            (NVL(:OLD.CDCLIENTE,       '0') <> NVL(:NEW.CDCLIENTE,       '0')) OR
            (NVL(TO_CHAR(:OLD.DTCOMPCONTREC, 'DD/MM/YYYY'),   '0') <> NVL(TO_CHAR(:NEW.DTCOMPCONTREC, 'DD/MM/YYYY'),   '0')) OR
            (NVL(:OLD.CDTPBAIXAREC,    '0') <> NVL(:NEW.CDTPBAIXAREC,    '0')) OR
            (NVL(:OLD.CDTPBAIXAPAG,    '0') <> NVL(:NEW.CDTPBAIXAPAG,    '0')) OR
            (NVL(:OLD.CDAJUCTREC,      '0') <> NVL(:NEW.CDAJUCTREC,      '0')) OR
            (NVL(:OLD.CDAJUCTPAG,      '0') <> NVL(:NEW.CDAJUCTPAG,      '0')) OR
            (NVL(:OLD.CDREDUCONT,      '0') <> NVL(:NEW.CDREDUCONT,      '0')) OR
            (NVL(TO_CHAR(:OLD.DTBAIXACOMPREC, 'DD/MM/YYYY'),  '0') <> NVL(TO_CHAR(:NEW.DTBAIXACOMPREC, 'DD/MM/YYYY'),  '0')) OR
            (NVL(:OLD.CDFILIALBAIREC,  '0') <> NVL(:NEW.CDFILIALBAIREC,  '0')) OR
            (NVL(:OLD.NRBAIXAREC,      '0') <> NVL(:NEW.NRBAIXAREC,      '0')) OR
            (NVL(:OLD.CDFILIALBAIPAG,  '0') <> NVL(:NEW.CDFILIALBAIPAG,  '0')) OR
            (NVL(:OLD.NRBAIXAPAG,      '0') <> NVL(:NEW.NRBAIXAPAG,      '0')) OR
            (NVL(:OLD.IDTPITUTLCOMREC, '0') <> NVL(:NEW.IDTPITUTLCOMREC, '0')) OR
            (NVL(TO_CHAR(:OLD.QTITCOMCONTREC),  '0') <> NVL(TO_CHAR(:NEW.QTITCOMCONTREC),  '0')) OR
            (NVL(TO_CHAR(:OLD.VRTOTALCOMREC),   '0') <> NVL(TO_CHAR(:NEW.VRTOTALCOMREC),   '0')) THEN
            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDEMPRESA || :OLD.NRLANCCOMPREC;
         END IF;
      ELSE
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDEMPRESA || :NEW.NRLANCCOMPREC;
      END IF;
      IF NVL(:OLD.CDEMPRESA, '0') <> NVL(:NEW.CDEMPRESA, '0') THEN
         V_DESC := SUBSTR(V_DESC || 'CdEmp=' || :NEW.CDEMPRESA, 1, 400);
      END IF;
      IF NVL(:OLD.NRLANCCOMPREC,'0') <>  NVL(:NEW.NRLANCCOMPREC,'0') THEN
         V_DESC := SUBSTR(V_DESC || ' NroComp=' || :NEW.NRLANCCOMPREC, 1, 400);
      END IF;
      IF (NVL(:OLD.CDFILIAL, '0') <> NVL(:NEW.CDFILIAL, '0')) OR
         (NVL(:OLD.NRLANBOLREC,'0') <>  NVL(:NEW.NRLANBOLREC,'0')) THEN
         V_DESC := SUBSTR(V_DESC || ' ChaveBol=' || :NEW.CDFILIAL || :NEW.NRLANBOLREC, 1, 400);
      END IF;
      IF NVL(:OLD.CDOPERLANCOMREC,'0') <> NVL(:NEW.CDOPERLANCOMREC, '0') THEN
         V_DESC := SUBSTR(V_DESC || ' CdOpLanc=' || :NEW.CDOPERLANCOMREC, 1, 400);
      END IF;
      IF NVL(TO_CHAR(:OLD.DTLANCOMCONTREC, 'DD/MM/YYYY'), '0') <> NVL(TO_CHAR(:NEW.DTLANCOMCONTREC, 'DD/MM/YYYY'), '0') THEN
         V_DESC := SUBSTR(V_DESC || ' DtLancC=' || TO_CHAR(:NEW.DTLANCOMCONTREC, 'DD/MM/YYYY'), 1, 400);
      END IF;
      IF NVL(:OLD.CDCLIENTE, '0') <>  NVL(:NEW.CDCLIENTE, '0') THEN
         V_DESC := SUBSTR(V_DESC || ' CdClie=' || :NEW.CDCLIENTE, 1, 400);
      END IF;
      IF NVL(TO_CHAR(:OLD.DTCOMPCONTREC, 'DD/MM/YYYY'), '0') <> NVL(TO_CHAR(:NEW.DTCOMPCONTREC, 'DD/MM/YYYY'), '0') THEN
         V_DESC := SUBSTR(V_DESC || ' DtCompRec=' || TO_CHAR(:NEW.DTCOMPCONTREC, 'DD/MM/YYYY'), 1, 400);
      END IF;
      IF NVL(:OLD.CDTPBAIXAREC, '0') <> NVL(:NEW.CDTPBAIXAREC, '0') THEN
         V_DESC := SUBSTR(V_DESC || ' TpBxRec=' || :NEW.CDTPBAIXAREC, 1, 400);
      END IF;
      IF NVL(:OLD.CDTPBAIXAPAG, '0') <> NVL(:NEW.CDTPBAIXAPAG, '0') THEN
         V_DESC := SUBSTR(V_DESC || ' TpBxPag=' || :NEW.CDTPBAIXAPAG, 1, 400);
      END IF;
      IF NVL(:OLD.CDAJUCTREC, '0') <> NVL(:NEW.CDAJUCTREC, '0') THEN
         V_DESC := SUBSTR(V_DESC || ' TpAjRec=' ||  :NEW.CDAJUCTREC, 1, 400);
      END IF;
      IF NVL(:OLD.CDAJUCTPAG, '0') <> NVL(:NEW.CDAJUCTPAG, '0') THEN
         V_DESC := SUBSTR(V_DESC || ' TpAjPag=' ||  :NEW.CDAJUCTPAG, 1, 400);
      END IF;
      IF NVL(:OLD.CDREDUCONT, '0') <> NVL(:NEW.CDREDUCONT, '0') THEN
         V_DESC := SUBSTR(V_DESC || ' CdReCont=' || :NEW.CDREDUCONT, 1, 400);
      END IF;
      IF NVL(TO_CHAR(:OLD.DTBAIXACOMPREC, 'DD/MM/YYYY'), '0') <> NVL(TO_CHAR(:NEW.DTBAIXACOMPREC, 'DD/MM/YYYY'), '0') THEN
         V_DESC := SUBSTR(V_DESC || ' DtBxComp=' || TO_CHAR(:NEW.DTBAIXACOMPREC, 'DD/MM/YYYY'), 1, 400);
      END IF;
      IF (NVL(:OLD.CDFILIALBAIREC, '0') <> NVL(:NEW.CDFILIALBAIREC, '0')) OR
         (NVL(:OLD.NRBAIXAREC, '0') <> NVL(:NEW.NRBAIXAREC, '0')) THEN
         V_DESC := SUBSTR(V_DESC || ' ChavBxRec=' || :NEW.CDFILIALBAIREC || :NEW.NRBAIXAREC, 1, 400);
      END IF;
      IF (NVL(:OLD.CDFILIALBAIPAG, '0') <> NVL(:NEW.CDFILIALBAIPAG, '0')) OR
         (NVL(:OLD.NRBAIXAPAG, '0') <>  NVL(:NEW.NRBAIXAPAG, '0')) THEN
         V_DESC := SUBSTR(V_DESC || ' ChavBxPag=' || :NEW.CDFILIALBAIPAG || :NEW.NRBAIXAPAG, 1, 400);
      END IF;
      IF NVL(:OLD.IDTPITUTLCOMREC, '0') <> NVL(:NEW.IDTPITUTLCOMREC, '0') THEN
         V_DESC := SUBSTR(V_DESC || ' IdItem=' || :OLD.IDTPITUTLCOMREC, 1, 400);
      END IF;
      IF NVL(TO_CHAR(:OLD.QTITCOMCONTREC), '0') <> NVL(TO_CHAR(:NEW.QTITCOMCONTREC), '0') THEN
         V_DESC := SUBSTR(V_DESC || ' QtItens=' || TO_CHAR(:NEW.QTITCOMCONTREC), 1, 400);
      END IF;
      IF NVL(TO_CHAR(:OLD.VRTOTALCOMREC), '0') <> NVL(TO_CHAR(:NEW.VRTOTALCOMREC), '0') THEN
         V_DESC := SUBSTR(V_DESC || ' VrComp=' || TO_CHAR(:NEW.VRTOTALCOMREC), 1, 400);
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN
      IF NOT V_DESC IS NULL THEN
         NMUSUARIO(V_USUARIO);
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('COMPENSACONTREC',  V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, V_DESC,
                V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVERRDM, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIN_COMPENSACONTREC','5.05.105'); END;
/

